;PTTRestore - Press-to-Test Workaround
; (C) 2007 by Brandon Wilson. All rights reserved. 
;Portions in util.asm, usb8x.inc, equates.inc (C) Dan Englender.

 include "settings.inc" ;Specific settings for this application
 NOLIST
 include "ti83plus.inc"
 LIST
 include "equates.inc" ;Equates and macros to be used
 include "header.asm"
 GLOBALS ON

 SEGMENT MAIN

 EXTERN PutSApp,IGetKey

Init:
       ld a,81h
       out (7),a
       xor a
       out (5),a
       B_CALL ClrLCDFull
       B_CALL HomeUp
       ld hl,sMainMenu
       call PutSApp
       push hl
       B_CALL NewLine
       pop hl
       ld b,3
$$:    push bc
       call PutSApp
       pop bc
       djnz $B
mainKeyLoop:
       call IGetKey
       cp kQuit
       jr z,exitApp
       cp kClear
       jr z,exitApp
       cp k1
       jr z,backUpRAM
       cp k2
       jr z,restoreRAM
       cp k3
       jr z,exitApp
       jr mainKeyLoop
backUpRAM:
       ld hl,2658h
       ld (appData),hl
       ld hl,2930h
       ld (appData+2),hl
       di
       ld a,07h
       out (5),a
       ld hl,8000h
       ld de,0C000h
       ld bc,4000h
       ldir
       dec a
       out (5),a
       ld a,80h
       out (7),a
       ld hl,8000h
       ld de,0C000h
       ld bc,4000h
       ldir
       ld a,81h
       out (7),a
       xor a
       out (5),a
       jr doneWait
restoreRAM:
       di
       ld a,87h
       out (7),a
       ld hl,(appData)
       ld de,2658h
       or a
       sbc hl,de
       jr nz,Init
       ld hl,(appData+2)
       ld de,2930h
       or a
       sbc hl,de
       jr nz,Init
       ld a,1
       out (5),a
       ld hl,8000h
       ld de,0C000h
       ld bc,4000h
       ldir
       dec a
       out (5),a
       ld a,86h
       out (7),a
       ld hl,8000h
       ld de,0C000h
       ld bc,4000h
       ldir
       ld a,81h
       out (7),a
doneWait:
       ld hl,6
       ld (curRow),hl
       ld hl,sDone
       call PutSApp
       B_CALL NewLine
       ld hl,sPressAnyKey
       call PutSApp
       call IGetKey
       jr Init
exitApp:
	B_CALL ClrLCDFull
       B_JUMP JForceCmdNoChar
sMainMenu:
       DB "PTTRestore",0
       DB "1) Back Up RAM  ",0
       DB "2) Restore RAM  ",0
       DB "3) Quit",0
sDone:
       DB "Done",0
sPressAnyKey:
       DB "Press any key",0CEh,0

